/* qksort - sort array a (dimension n) using quicksort
 */
#include "local.h"
void qksort(a, n)
	int a[];
	int n;
	{
	iqksort(a, &a[n-1]);
	isort(a, n);
	}
static void iqksort(lo, hi)
	int *lo, *hi;
	{
	int *mid = lo + (hi - lo) / 2;
	register int *i;
	register int *lastlo;
	int t;
	register int tmp;

	if (hi < lo + 16)	/* cannot use   (hi < lo + 16) */
		return;
	SWAP(*lo, *mid, tmp);
	t = *lo;
	lastlo = lo;
	for (i = lo+1; i <= hi; ++i)
		{
		if (*i < t)
			{
			++lastlo;
			SWAP(*lastlo, *i, tmp);
			}
		}
	SWAP(*lo, *lastlo, tmp);
	iqksort(lo, lastlo - 1);
	iqksort(lastlo + 1, hi);
	}
/* isort - sort array a (dimension n) using insertion sort
 */
void isort(a, n)
	int a[];
	int n;
	{
	int i;
	register int *pj;
	register int *pjm;
	int t;

	for (i = 1; i < n; ++i)	/* a[0:i-1]=>sorted */
		{
		t = a[i];
		pj = &a[i];
		pjm = pj - 1;
		while (pj > a && *pjm > t)
			{
			*pj = *pjm;
			--pj;
			--pjm;
			}
		*pj = t;
		}
	/* a=>sorted */
	}
#ifdef TRYMAIN
#include <math.h>
main(ac, av)
	int ac;
	char *av[];
	{
	int i;
	int lim;
	static int a[10000];
	double nlogn;
	double tim;
	long cputim();

	lim = atoi(av[1]);
	printf("lim=%d\n", lim);
	for (i = 0; i < lim; ++i)
		a[i] = rand();
	cputim();
	qksort(a, lim);
	tim = cputim() * 1e6 / 60;
	printf("cpu time = %.3f (sec)\n", tim / 1e6);
	nlogn = lim * log((double)lim) / log(2.);
	printf("log N = %.3f\n", log((double)lim) / log(2.));
	printf("N log N = %.3f\n", nlogn);
	printf("cpu time = %.2f N log N (usec)\n", tim / nlogn);
	for (i = 0; i < lim-1; ++i)
		{
		if (a[i] > a[i+1])
			error("bad value", "");
		}
	exit(SUCCEED);
	}
#endif
